clear all
Ts = 10;     %  1; 2; 5; 10
spread=10;   % 20; 10; 8; 2;
error_goal=0.000001;

t=0:Ts:100; y=exp(-.03*t).*sin(0.003*t.*t)+0.1*randn(1,100/Ts+1);
ti=0:.1:100;yi=exp(-.03*ti).*sin(0.003*ti.*ti);

figure(1);plot(t,y,'ko',ti,yi,'k','LineWidth',1); hold on
grid on;
color=['m','g','r','b','c','y','k']
mseR=[0,0,0,0,0];
mseM=mseR;

for i=1:4
  MaxN=5*i; % Maximum number of neurons
  
  netr=newrb(t,y,error_goal,spread,MaxN)
  yr=sim(netr,ti)
  mseR(i)=sqrt(mean((yr-yi).^2));
  plot(ti,yr,color(i),'LineWidth',2)
end
Ns=100/Ts;

legend({['samples',num2str(Ns,3)],...
    ['function   MSE'],...
    [' 5 RBFs ',num2str(mseR(1),3)],...
    ['10 RBFs ',num2str(mseR(2),3)],...
    ['15 RBFs ',num2str(mseR(3),3)],...
    ['20 RBFs ',num2str(mseR(4),3)]},'FontSize',14)
title(['RBF comparison - MSE over ti=0:0.1:100,',...
      'yi=exp(-.03*ti).*sin(0.003*ti.*ti))'])
hold off

figure(2);plot(t,y,'ko',ti,yi,'k','LineWidth',1); hold on
grid on;

for i=1:4
  MaxN=5*i;
  netf=newff(t,y,MaxN); %feedforwardnet
  netf.divideParam.trainRatio=1;
  netf.divideParam.valRatio=.15;
  netf.divideParam.testRatio=.15;

  netf=train(netf,t,y)
  yf=sim(netf,ti);
  mseM(i)=sqrt(mean((yf-yi).^2));

  plot(ti,yf,color(i),'LineWidth',2);
end

legend({['samples', num2str(Ns,3)],'function   MSE',...
    [' 5 MLPs ',num2str(mseM(1),3)],...
    ['10 MLPs ',num2str(mseM(2),3)],...
    ['15 MLPs ',num2str(mseM(3),3)],...
    ['20 MLPs ',num2str(mseM(4),3)]},'FontSize',14)
title(['MLP comparison - MSE over ti=0:0.1:100,',...
      'yi=exp(-.03*ti).*sin(0.003*ti.*ti))'])

hold off
